/*
 * Rob.cpp
 *
 *  Created on: 17 janv. 2011
 *      Author: robot1
 */

#include "Rob.h"
#include <iostream>

#define MAP 1

using namespace std;

int Rob::initializeCom()
// Algorithme :
//
{
	if (comKhepera.Open(usbPort) && comKhepera.SetPortConfiguration(
			CCom::CCOM_BR9600, CCom::CCOM_8_BITS, CCom::CCOM_NONE,
			CCom::CCOM_1_BIT)) {
		//		comKhepera.ConfigureSpeedProfileController(127, 256, 127, 256);
		//		comKhepera.ConfigurePIDController(0, 0, 0);
		return 1;
	} else {
		return 0;
	}
}

int Rob::moveTo(s_position destination)
// Algorithme :
//
{
	double pVect;
	double pScal;
	double norme1;
	double norme2;
	int vRoueInt;
	double rayon;
	s_direction AC;
	s_direction x;
	s_direction w;
	s_direction dirTemp;
	s_direction dirDest;
	s_position posTemp;
	bool finished = false;
	s_direction dirInit;
	int semaphore = BobbyUtils::getSemaphore(STATE_SEM_FILENAME);
	mem_struct* sm_etatjeu = (mem_struct*) BobbyUtils::getSharedMemory(
			STATE_MEMORY_FILENAME, sizeof(mem_struct));

	destination.x = max(30, destination.x);
	destination.x = min(LARGEUR_TERRAIN_X - 30, destination.x);
	destination.y = max(30, destination.y);
	destination.y = min(LONGUEUR_TERRAIN_Y / 2 - 30, destination.y);

	if (idRob == 1) {
		BobbyUtils::takeSemaphore(semaphore);
		setPosition(sm_etatjeu->posK1);
		setDirection(sm_etatjeu->dirK1);
		BobbyUtils::giveSemaphore(semaphore);
	} else {
		BobbyUtils::takeSemaphore(semaphore);
		setPosition(sm_etatjeu->posK2);
		setDirection(sm_etatjeu->dirK2);
		BobbyUtils::giveSemaphore(semaphore);
	}

	if (!((getPosition().x < destination.x - TOLERANCE) || (getPosition().x
			> destination.x + TOLERANCE) || (getPosition().y < destination.y
			- TOLERANCE) || (getPosition().y > destination.y + TOLERANCE))) {
		stop();
		return 0;
	}

	dirInit.u = destination.x - getPosition().x;
	dirInit.v = destination.y - getPosition().y;
	//	dirInit.u = pBalle.x - getPosition().x;
	//	dirInit.v = pBalle.y - getPosition().y;
	rotate(dirInit);

	///----- FIN ROTATION

	posTemp = getPosition();
	comKhepera.SetSpeed(VITESSE_MAX, VITESSE_MAX); // Déplacement sur une certaine distance minimale pour avoir la tangente au mouvement
	while ((posTemp.x - getPosition().x) * (posTemp.x - getPosition().x)
			+ (posTemp.x - getPosition().x) * (posTemp.x - getPosition().x)
			< 100) {

		usleep(1000);
		if (idRob == 1) {
			BobbyUtils::takeSemaphore(semaphore);
			setPosition(sm_etatjeu->posK1);
			BobbyUtils::giveSemaphore(semaphore);
		} else {
			BobbyUtils::takeSemaphore(semaphore);
			setPosition(sm_etatjeu->posK2);
			BobbyUtils::giveSemaphore(semaphore);
		}
	}

	//--- fin attente

	dirTemp.u = getPosition().x - posTemp.x;
	dirTemp.v = getPosition().y - posTemp.y;

	posTemp = getPosition();

	dirDest.u = destination.x - posTemp.x;
	dirDest.v = destination.y - posTemp.y;

	//int test=0;
	int gardeFou;

	while (!finished) {
		gardeFou = 0;

		if (idRob == 1) {
			BobbyUtils::takeSemaphore(semaphore);
			setPosition(sm_etatjeu->posK1);
			setDirection(sm_etatjeu->dirK1);
			BobbyUtils::giveSemaphore(semaphore);
		} else {
			BobbyUtils::takeSemaphore(semaphore);
			setPosition(sm_etatjeu->posK2);
			setDirection(sm_etatjeu->dirK2);
			BobbyUtils::giveSemaphore(semaphore);
		}

		if ((position.x < destination.x - TOLERANCE) || (position.x
				> destination.x + TOLERANCE) || (position.y < destination.y
				- TOLERANCE) || (position.y > destination.y + TOLERANCE)) {
			//VERIFIER LES DIVISIONS PAR 0 EN VERIFIANT LE PRODUIT VECTORIEL


			norme1 = sqrt(dirDest.v * dirDest.v + dirDest.u * dirDest.u);

			norme2 = sqrt(dirTemp.u * dirTemp.u + dirTemp.v * dirTemp.v);

			pVect = ((dirTemp.u * dirDest.v) - (dirTemp.v * dirDest.u))
					/ (norme1 * norme2);

			pScal = (dirTemp.u * dirDest.u + dirTemp.v * dirDest.v) / (norme1
					* norme2);

			AC.u = (destination.x - position.x) / 2;
			AC.v = (destination.y - position.y) / 2;
			w.u = destination.y - position.y;
			w.v = position.x - destination.x;
			x.u = dirTemp.v;
			x.v = -dirTemp.u;

			//cout << "pVect : " << pVect << endl;

			posTemp = getPosition();

			if (pVect > SEUIL_DIRECTION || pVect < -SEUIL_DIRECTION) {
				rayon = BobbyUtils::abs(((w.u * (AC.v) - w.v * (AC.u)) / (w.u
						* x.v - w.v * x.u)) * sqrt(x.u * x.u + x.v * x.v)); //rayon de courbure a adopter

				if (pScal < 0) {
					stop();
					return (moveTo(destination));
				} else {
					//cout << "rayon : " << rayon << endl;

					//				rayon = 20;
					//				pVect = 1;


					vRoueInt = round((double) VITESSE_MAX * (rayon
							- (LARGEUR_K_PX / 2.0)) / (rayon + (LARGEUR_K_PX
							/ 2.0)));

					vRoueInt = max(vRoueInt, VITESSE_MAX / 3); //pour ne pas trop tourner en rond !

					//if (!test){


					if (pVect < 0) { //droite
						comKhepera.SetSpeed(VITESSE_MAX, vRoueInt);
						//cout << "droite" << endl;
						cout << VITESSE_MAX << " : " << vRoueInt << endl;
					} else { //gauche
						comKhepera.SetSpeed(vRoueInt, VITESSE_MAX);
						//cout << "gauche" << endl;
						cout << vRoueInt << " : " << VITESSE_MAX << endl;
					}
					//}
				}
			} else {
				comKhepera.SetSpeed(VITESSE_MAX, VITESSE_MAX);
				//cout << "on va tout droit !!!!!" << endl;
				cout << VITESSE_MAX << " : " << VITESSE_MAX << endl;
			}

			//-- ATTENTE en dessous

			while ((posTemp.x - getPosition().x)
					* (posTemp.x - getPosition().x) + (posTemp.x
					- getPosition().x) * (posTemp.x - getPosition().x) < 10
					* 10 && gardeFou < 3000) {

				usleep(1000);
				if (idRob == 1) {
					BobbyUtils::takeSemaphore(semaphore);
					setPosition(sm_etatjeu->posK1);
					BobbyUtils::giveSemaphore(semaphore);
				} else {
					BobbyUtils::takeSemaphore(semaphore);
					setPosition(sm_etatjeu->posK2);
					BobbyUtils::giveSemaphore(semaphore);
				}
				gardeFou++;
			}

			dirTemp.u = getPosition().x - posTemp.x;
			dirTemp.v = getPosition().y - posTemp.y;

			if (gardeFou >= 3000) {
				stop();
				cout << "Robot Bloqué" << endl;
				return 1;
			}

		} else {
			finished = true;
			stop();
		}
	}

	return 0;
}

int Rob::moveDef(int abscisse) { //mieux vaut que les robots soient déjà orientés !

	if (abscisse < 20 || abscisse > LARGEUR_TERRAIN_X - 20) {
		return 1;
	}

	int semaphore = BobbyUtils::getSemaphore(STATE_SEM_FILENAME);
	mem_struct* sm_etatjeu = (mem_struct*) BobbyUtils::getSharedMemory(
			STATE_MEMORY_FILENAME, sizeof(mem_struct));

	s_direction newDirection; // selon Ox
	newDirection.u = 1;
	newDirection.v = 0;
	double seuilSouple = 0.9;

	double normeDir;

	if (idRob == 1) {
		BobbyUtils::takeSemaphore(semaphore);
		setPosition(sm_etatjeu->posK1);
		BobbyUtils::giveSemaphore(semaphore);
	} else {
		BobbyUtils::takeSemaphore(semaphore);
		setPosition(sm_etatjeu->posK2);
		BobbyUtils::giveSemaphore(semaphore);
	}

	normeDir = sqrt((double) (getDirection().u * getDirection().u
			+ getDirection().v * getDirection().v));

	double prodScal = ((double) getDirection().u * (double) newDirection.u
			+ (double) getDirection().v * (double) newDirection.v) / normeDir;

	if (prodScal < seuilSouple) {
		rotate(newDirection);
	}

	if (getPosition().x < abscisse) {// avancer
		if ((abscisse - getPosition().x) < TOLERANCE) {
			return 0;
		}
		comKhepera.SetSpeed(VITESSE_MAX, VITESSE_MAX);
	} else {// reculer
		if ((getPosition().x - abscisse) < TOLERANCE) {
			return 0;
		}
		comKhepera.SetSpeed(-VITESSE_MAX, -VITESSE_MAX);
	}

	while (BobbyUtils::abs((double) (getPosition().x - abscisse))
			> (double) TOLERANCE) {
		usleep(100000);
		if (idRob == 1) {
			BobbyUtils::takeSemaphore(semaphore);
			setPosition(sm_etatjeu->posK1);
			BobbyUtils::giveSemaphore(semaphore);
		} else {
			BobbyUtils::takeSemaphore(semaphore);
			setPosition(sm_etatjeu->posK2);
			BobbyUtils::giveSemaphore(semaphore);
		}
	}

	stop();

	return 0;

}

int Rob::shoot(s_position destination) {

	int gardeFou = 0;
	int semaphore = BobbyUtils::getSemaphore(STATE_SEM_FILENAME);
	mem_struct* sm_etatjeu = (mem_struct*) BobbyUtils::getSharedMemory(
			STATE_MEMORY_FILENAME, sizeof(mem_struct));
	s_position derriere;
	s_direction balle;
	derriere.x = destination.x;
	derriere.y = destination.y - 35;
	derriere.y = max(derriere.y, 20); //pour ne pas l'envoyer dans le mur

	s_position devant;
	devant.x = destination.x;
	devant.y = destination.y + 50;
	moveTo(derriere);
	if (idRob == 1) {
		BobbyUtils::takeSemaphore(semaphore);
		setPosition(sm_etatjeu->posK1);
		BobbyUtils::giveSemaphore(semaphore);
	} else {
		BobbyUtils::takeSemaphore(semaphore);
		setPosition(sm_etatjeu->posK2);
		BobbyUtils::giveSemaphore(semaphore);
	}

	balle.u = destination.x - getPosition().x;
	balle.v = destination.y - getPosition().y;

	//moveTo(devant);
	rotate(balle);
	comKhepera.SetSpeed(39, 39);

	while (getPosition().y < destination.y && gardeFou < 20) {
		usleep(100000);
		gardeFou++;
		if (idRob == 1) {
			BobbyUtils::takeSemaphore(semaphore);
			setPosition(sm_etatjeu->posK1);
			BobbyUtils::giveSemaphore(semaphore);
		} else {
			BobbyUtils::takeSemaphore(semaphore);
			setPosition(sm_etatjeu->posK2);
			BobbyUtils::giveSemaphore(semaphore);
		}
	}
	stop();
	sleep(1);
	comKhepera.SetSpeed(-20, -20);
	sleep(2);
	stop();
	return 1;
}

int Rob::rotate(s_direction newDirection) {
	bool rotating = true;
	int directionRotation = 0; // 0 aucune rotation / 1 rotation à droite / 2 rotation à gauche
	double normeNewDir;
	double normeDir;
	int semaphore = BobbyUtils::getSemaphore(STATE_SEM_FILENAME);
	mem_struct* sm_etatjeu = (mem_struct*) BobbyUtils::getSharedMemory(
			STATE_MEMORY_FILENAME, sizeof(mem_struct));
	while (rotating) {
		if (idRob == 1) {
			BobbyUtils::takeSemaphore(semaphore);
			//std::cout << "On prend le token depuis Evaluer Etat" << std::endl;
			setDirection(sm_etatjeu->dirK1);
			BobbyUtils::giveSemaphore(semaphore);
			//std::cout << "On rend le token depuis Evaluer Etat" << std::endl;
		} else {
			BobbyUtils::takeSemaphore(semaphore);
			//std::cout << "On prend le token depuis Evaluer Etat" << std::endl;
			setDirection(sm_etatjeu->dirK2);
			BobbyUtils::giveSemaphore(semaphore);
			//std::cout << "On rend le token depuis Evaluer Etat" << std::endl;
		}
		normeDir = sqrt((double) (getDirection().u * getDirection().u
				+ getDirection().v * getDirection().v));
		normeNewDir = sqrt((double) (newDirection.u * newDirection.u
				+ newDirection.v * newDirection.v));
		double prodScal = ((double) getDirection().u * (double) newDirection.u
				+ (double) getDirection().v * (double) newDirection.v)
				/ (normeDir * normeNewDir);
		if (prodScal > SEUIL_TOLERE) {
			//			cout << idRob << endl;
			//			cout << "u : " << getDirection().u << endl;
			//			cout << "v : " << getDirection().v << endl;
			//			cout << "u' : " << newDirection.u << endl;
			//			cout << "v' : " << newDirection.v << endl;
			//			cout << "Produit scal. : " << prodScal << endl;
			// Condition d'arrêt
			stop();
			rotating = false;
		} else {

			//cout<<idRob<<endl;

			double prodVect = getDirection().u * newDirection.v
					- getDirection().v * newDirection.u;
			if (prodVect <= 0) {
				if (directionRotation != 1) {
					//cout << "Produit vect. : " << prodVect << endl;
					directionRotation = 1;
					comKhepera.SetSpeed(ROTATION_SPEED, -ROTATION_SPEED); // Tourner à droite
				}
			} else {
				if (directionRotation != 2) {
					//cout << "Produit vect. : " << prodVect << endl;
					directionRotation = 2;
					comKhepera.SetSpeed(-ROTATION_SPEED, ROTATION_SPEED); // Tourner à gauche
				}
			}
		}
	}
	return 0;
}

int Rob::stop() {
	comKhepera.SetSpeed(0, 0);
	return 1;
}

Rob::Rob() {
#ifdef MAP
	cout << "Appel au constructeur de <Rob>" << endl;
#endif
}
Rob::Rob(string port, int numeroRob = 1) {
#ifdef MAP
	cout << "Appel au constructeur de <Rob>" << endl;
#endif
	this->usbPort = port;
	this->idRob = numeroRob;
}
Rob::~Rob() {
	stop();
#ifdef MAP
	cout << "Appel au destructeur de <Rob>" << endl;
#endif

}
