//============================================================================
// Name        : BobbyScor.cpp
// Author      : Team Bobby
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================
#include "cv.h"
#include "highgui.h"
#define MAP 1
#include <iostream>
#include "communication/CCom.h"
#include <cstdlib>
#include "video/Point.h"
#include "video/ImageProcessor.h"
#include <unistd.h>     /* fork() */
#include <sys/types.h>  /* pid_t */
#include <sys/wait.h>   /* wait() */
#include <sys/ipc.h>    /* ftok() */
#include <sys/shm.h>	/* shmget() */
#include <sys/sem.h>	/* semget() */
#include <sys/msg.h>	/* msgget() */
#include <errno.h>
#include "IA/Stratege.h"
#include "physique/Rob.h"
using namespace std;

int main() {

	int check = 0;
	int bobbyKiller = BobbyUtils::getSemaphore(STATE_SEM_BOBBYKILLER);
	check = BobbyUtils::initSemaphore(bobbyKiller);
	cout << "videoKiller" << endl;
	int videoKiller = BobbyUtils::getSemaphore(STATE_SEM_VIDEOKILLER);
	check = BobbyUtils::initSemaphore(videoKiller);
	cout << "videoKiller" << endl;
	int tacheFilleKiller = BobbyUtils::getSemaphore(STATE_SEM_TFKILLER);
	check = BobbyUtils::initSemaphore(tacheFilleKiller);
	cout << "tacheFilleKiller" << endl;
	int sm_protector = BobbyUtils::getSemaphore(STATE_SEM_FILENAME);
	check = BobbyUtils::initSemaphore(sm_protector);
	cout << "sm_protector" << endl;
	int sm_console = BobbyUtils::getSemaphore(STATE_SEM_CONSOLE);
	check = BobbyUtils::initSemaphore(sm_console);
	cout << "sm_console" << endl;
	mem_struct* sm_etatjeu = (mem_struct*) BobbyUtils::getSharedMemory(
			STATE_MEMORY_FILENAME, sizeof(mem_struct));
	pid_t pid;

	if ((pid = fork()) == 0) {
		BobbyUtils::takeSemaphore(videoKiller);
		CvCapture* capture = cvCaptureFromCAM(-1);
		ImageProcessor::InitField(capture);
		BobbyUtils::giveSemaphore(videoKiller);
		sleep(1);
		cout << "on commence la video (pid : " << getpid() << ")" << endl;
		ImageProcessor::Run(capture);
		cout << "on est de retour dans le main" << endl;
		cvReleaseCapture(&capture);
		exit(0);

	} else {
		sleep(1);
		if ((pid = fork()) == 0) {
			cout << " getchar (pid : " << getpid() << ")" << endl;
			BobbyUtils::takeSemaphore(bobbyKiller);
			getchar();
			BobbyUtils::giveSemaphore(bobbyKiller);
			exit(0);
		} else {
			BobbyUtils::takeSemaphore(videoKiller);
			cout << "on prend videoKiller main" << endl;

			Stratege strat;
			strat.EvaluerEtat();

			//		Rob* K1 = new Rob(s2, 1);
			//		int lol = K1->initializeCom();
			//		cout << lol << endl;
			//		Rob* K2 = new Rob(s1, 2);
			//		int lol2 = K2->initializeCom();
			//		cout << lol2 << endl;
			//		sleep(3);

			//		CCom* comKhepera = new CCom();
			//
			//		if (comKhepera->Open("/dev/ttyUSB1") && comKhepera->SetPortConfiguration(
			//				CCom::CCOM_BR9600, CCom::CCOM_8_BITS, CCom::CCOM_NONE,
			//				CCom::CCOM_1_BIT)) {
			////			comKhepera.ConfigureSpeedProfileController(127, 256, 127, 256);
			////			comKhepera.ConfigurePIDController(0, 0, 0);
			//			cout<<"Initialisation Com !"<<endl;
			//		} else {
			//			cout<<"Erreur Com !"<<endl;
			//		}
			//
			//
			//		cout <<"ESSAI 1 -----------------------------"<<endl;
			//		comKhepera->ConfigurePIDController(3000,20,4000);
			//		comKhepera->SetSpeed(30,30);
			//		sleep(1);
			//		string r_s = comKhepera->GetSpeed();
			//		cout <<"Speed : " << r_s<<endl;
			//		sleep(1);
			//		comKhepera->SetSpeed(0,0);
			//		sleep(1);

			//		BobbyUtils::takeSemaphore(sm_protector);
			//		s_position pBalle = sm_etatjeu->posBalle; // A supprimer
			//
			//		K1->setPosition(sm_etatjeu->posK1);
			//		K1->setDirection(sm_etatjeu->dirK1);
			//		K2->setPosition(sm_etatjeu->posK2);
			//		K2->setDirection(sm_etatjeu->dirK2);
			//		BobbyUtils::giveSemaphore(sm_protector);
			//
			//		//s_position aezaezeaz = s_position {120,150};
			//		s_direction aez;
			//		aez.u = pBalle.x - K1->getPosition().x;
			//		aez.v = pBalle.y - K1->getPosition().y;
			//		s_direction aez1;
			//		aez1.u = pBalle.x - K2->getPosition().x;
			//		aez1.v = pBalle.y - K2->getPosition().y;
			//
			//		s_position pBalleb;
			//		pBalleb.x = pBalle.x;
			//		pBalleb.y = pBalle.y;
			//		s_position milieu;
			//		milieu.x = MILIEU_DE_ZONE;
			//		milieu.y = MILIEU_DE_TERRAIN - 100;
			//		s_position posi;
			//		posi.x = 50;
			//		posi.y = 50;
			//
			//		cout << "X1 : " << K1->getPosition().x << endl;
			//		cout << "Y1 : " << K1->getPosition().y << endl;
			//		cout << "X2 : " << K2->getPosition().x << endl;
			//		cout << "Y2 : " << K2->getPosition().y << endl;
			//
			//		int t = 0;
			//
			//		K1->shoot(pBalleb);
			//while(K2->moveTo(posi) && t<2) t++;
			//K2->moveTo(pBalleb);

			//cout << result << endl;
			//sleep(5);

			//
			//		K1->moveTo(aezaezeaz);
			//		K2->moveTo(aezaezeaz);
			//		delete K2;


			BobbyUtils::giveSemaphore(videoKiller);

			cout << "on relache videoKiller main" << endl;

			int status;
			pid_t o = wait(&status);
			o = wait(&status);

			if (BobbyUtils::unsetSharedMemory(sm_etatjeu) != 0) {
				BobbyUtils::takeSemaphore(sm_console);
				cout << "Problème Shared Memory" << endl;
				BobbyUtils::giveSemaphore(sm_console);
			}
			cout << "Shared Memory" << endl;

			int tacheFilleKiller = BobbyUtils::getSemaphore(STATE_SEM_TFKILLER);
			BobbyUtils::takeSemaphore(tacheFilleKiller);
			if (BobbyUtils::removeSemaphore(tacheFilleKiller) == -1) {
				BobbyUtils::takeSemaphore(sm_console);
				cout << "Problème FilleKiller" << endl;
				BobbyUtils::giveSemaphore(sm_console);
			}
			cout << "tacheFilleKiller" << endl;

			if (BobbyUtils::removeSemaphore(bobbyKiller) == -1) {
				BobbyUtils::takeSemaphore(sm_console);
				cout << "Problème Sem Bobby" << endl;
				BobbyUtils::giveSemaphore(sm_console);
			}
			cout << "bobbyKiller" << endl;

			BobbyUtils::takeSemaphore(sm_protector);
			if (BobbyUtils::removeSemaphore(sm_protector) == -1) {
				BobbyUtils::takeSemaphore(sm_console);
				cout << "Problème State" << endl;
				BobbyUtils::giveSemaphore(sm_console);
			}
			cout << "sm_protector" << endl;

			BobbyUtils::takeSemaphore(videoKiller);
			if (BobbyUtils::removeSemaphore(videoKiller) == -1) {
				BobbyUtils::takeSemaphore(sm_console);
				cout << "Problème videoKiller" << endl;
				BobbyUtils::giveSemaphore(sm_console);
			}
			cout << "videoKiller" << endl;

			BobbyUtils::takeSemaphore(sm_console);
			if (BobbyUtils::removeSemaphore(sm_console) == -1) {
				cout << "Problème sm_console" << endl;
			}
			cout << "sm_console" << endl;
			//		delete K1;
			//		delete K2;
		}
	}
}
