/*
 * Stratege.h
 *
 *  Created on: 17 janv. 2011
 *      Author: robot1
 */

#ifndef STRATEGE_H_
#define STRATEGE_H_

#include "../physique/Elem.h"
#include "../physique/Rob.h"
#include "../physique/Balle.h"
#include "signal.h"
#include "iostream"
#include "stdlib.h"
#include "../BobbyUtils.h"
#include <sys/wait.h>   /* wait() */
#include <errno.h>
enum Etat {
	ATTAQUE, DEFENSE, REPLACEMENT, AUCUN
};
static const string s1 = "/dev/ttyUSB0";
static const string s2 = "/dev/ttyUSB2";

class Stratege {
public:
	//----------------------------------------------------- Méthodes publiques
	void EvaluerEtat();
	//------------------------------------------------- Surcharge d'opérateurs

	//-------------------------------------------- Constructeurs - destructeur
	Stratege();
	virtual ~Stratege();
	//------------------------------------------------------------------ PRIVE

protected:
	//----------------------------------------------------- Méthodes protégées

	pid_t ChangementStrat(Etat etat);
private:
	//------------------------------------------------------- Méthodes privées

protected:
	//----------------------------------------------------- Attributs protégés
	Etat etat_courant;
	Rob* khep1;
	Rob* khep2;
	Balle* ballon;
	pid_t strategie_courante;

	pid_t Attaque();
	pid_t Defense();
	pid_t Replacement();

	int sm_console;
	int videoKiller;
	int tacheFilleKiller;
	int sm_protector;
	int bobbyKiller;

	mem_struct* sm_etatjeu;
private:
	//------------------------------------------------------- Attributs privés

	//---------------------------------------------------------- Classes amies

	//-------------------------------------------------------- Classes privées

	//----------------------------------------------------------- Types privés

};

#endif /* STRATEGE_H_ */
