/*
 * Rob.h
 *
 *  Created on: 17 janv. 2011
 *      Author: robot1
 */
#include "Elem.h"
#include "../communication/CCom.h"
#include "../BobbyUtils.h"
#include "math.h"
#ifndef ROB_H_
#define ROB_H_

#define ROTATION_SPEED 5
#define VITESSE_MAX 25//40
#define TOLERANCE 15
#define LARGEUR_K_PX 28//28 //largeur du terrain : 103cm, largeur sur l'image : 480px, largeur khépéra : 6cm => largeur khépéra sur image = 28px
#define SEUIL_DIRECTION 0.05
#define SEUIL_TOLERE 0.96

class Rob: public Elem {
public:
	//----------------------------------------------------- Méthodes publiques
	int initializeCom();
	int moveTo(s_position destination);
	int moveDef(int);
	int shoot(s_position destination);
	int rotate(s_direction direction);
	int stop();
	//------------------------------------------------- Surcharge d'opérateurs

	//-------------------------------------------- Constructeurs - destructeur
	Rob();
	// Mode d'emploi :
	//
	// Contrat :
	//
	Rob(string port, int numeroRob);
	// Mode d'emploi :
	//
	// Contrat :
	//
	~Rob();
	// Mode d'emploi :
	//
	// Contrat :
	//


	//------------------------------------------------------------------ PRIVE

protected:
	//----------------------------------------------------- Méthodes protégées

private:
	//------------------------------------------------------- Méthodes privées

protected:
	//----------------------------------------------------- Attributs protégés
	string usbPort;
	int idRob;
	CCom comKhepera;
private:
	//------------------------------------------------------- Attributs privés

	//---------------------------------------------------------- Classes amies

	//-------------------------------------------------------- Classes privées

	//----------------------------------------------------------- Types privés
};

#endif /* ROB_H_ */
