/*************************************************************************
                           Point  -  description
                             -------------------
    début                : Janvier 2010
    copyright            : (C) 2010 par ESCANDELL Stéphane
    e-mail               : stephane.escandell@gmail.com
*************************************************************************/

//---------- Réalisation de la classe <Point> (fichier Point.cpp) --

//---------------------------------------------------------------- INCLUDE

//-------------------------------------------------------- Include système
using namespace std;
#include <iostream>

//------------------------------------------------------ Include personnel

//------------------------------------------------------------- Constantes

//---------------------------------------------------- Variables de classe

//----------------------------------------------------------- Types privés


//----------------------------------------------------------------- PUBLIC
//-------------------------------------------------------- Fonctions amies

//----------------------------------------------------- Méthodes publiques
// type $MODULE$::Méthode ( liste de paramètres )
// Algorithme :
//
//{
//} //----- Fin de Méthode
template <typename T>
double Point<T>::Distance(const Point<T> & aPoint)
{
	return sqrt(pow(x-aPoint.x,2)+pow(y-aPoint.y,2));
}

//------------------------------------------------- Surcharge d'opérateurs
template <typename T>
Point<T> & Point<T>::operator = ( const Point<T> & aPoint )
{
	x = aPoint.x;
	y = aPoint.y;

	return *this;
}


//-------------------------------------------- Constructeurs - destructeur
template <typename T>
template <typename U>
Point<T>::Point ( const Point<U> & aPoint )
// Algorithme :
//
{
#ifdef MAP
    cout << "Appel au constructeur de copie de <Point>" << endl;
#endif
	x = aPoint.x;
	y = aPoint.y;
} //----- Fin de Point (constructeur de copie)

template <typename T>
Point<T>::Point ( )
// Algorithme :
//
{
#ifdef MAP
    cout << "Appel au constructeur de <Point>" << endl;
#endif
} //----- Fin de Point

template <typename T>
Point<T>::Point ( T aX, T aY):x(aX),y(aY)
// Algorithme :
//
{
#ifdef MAP
    cout << "Appel au constructeur de <Point(aX,aY)>" << endl;
#endif
} //----- Fin de Point

template <typename T>
Point<T>::~Point ( )
// Algorithme :
//
{
#ifdef MAP
    cout << "Appel au destructeur de <Point>" << endl;
#endif
} //----- Fin de ~Point


//------------------------------------------------------------------ PRIVE

//----------------------------------------------------- Méthodes protégées

//------------------------------------------------------- Méthodes privées

